Alternc  latest
Alternc logiel libre pour l'hébergement
top_mysql_users
Go to the documentation of this file.
1 #!/bin/bash
2 #
3 # $Id: top_mysql_users 22 2005-04-11 17:21:15Z jerome $
4 # ----------------------------------------------------------------------
5 # AlternC - Web Hosting System
6 # Copyright (C) 2002 by the AlternC Development Team.
7 # http://alternc.org
8 # ----------------------------------------------------------------------
9 # Based on:
10 # Valentin Lacambre's web hosting softwares: http://altern.org/
11 # ----------------------------------------------------------------------
12 # LICENSE
13 #
14 # This program is free software; you can redistribute it and/or
15 # modify it under the terms of the GNU General Public License (GPL)
16 # as published by the Free Software Foundation; either version 2
17 # of the License, or (at your option) any later version.
18 #
19 # This program is distributed in the hope that it will be useful,
20 # but WITHOUT ANY WARRANTY; without even the implied warranty of
21 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
22 # GNU General Public License for more details.
23 #
24 # To read the license please visit http://www.gnu.org/copyleft/gpl.html
25 # ----------------------------------------------------------------------
26 # Original Author of file: Jerome Moinet
27 # Purpose of file: Parse the mysql logs to give the n most active users
28 # ----------------------------------------------------------------------
29 #
30 echo "This script does not work with this AlternC version"
31 exit 1
32 PATH=""
33 PROG_NAME=top_mysql_users
34 PROG_VERSION=0.1.0
35 ALTERNC_ROOT=/var/alternc
36 ALTERNC_ETC=/etc/alternc
37 ALTERNC_LIB=/usr/lib/alternc
38 ALTERNC_CONF_FILE=$ALTERNC_ETC/local.sh
39 LOG_DIR=/var/log
40 LOG_FILE=$LOG_DIR/mysql.log
41 TMP_ROOT=$ALTERNC_ROOT/tmp
42 RES_FILE=$TMP_ROOT/$PROG_NAME.res.$$
43 LOCK_FILE=/run/$PROG_NAME
44 export TEXTDOMAIN=alternc-admintools
45 YES=yes
46 NO=no
47 
48 # Be sure to use the right programs
49 # and be sure they are there
50 awk=/usr/bin/awk
51 grep=/bin/grep
52 cat=/bin/cat
53 zcat=/bin/zcat
54 head=/usr/bin/head
55 id=/usr/bin/id
56 sort=/usr/bin/sort
57 rm=/bin/rm
58 sed=/bin/sed
59 cut=/usr/bin/cut
60 tail=/usr/bin/tail
61 ls=/bin/ls
62 gettext=/usr/bin/gettext
63 printf=/usr/bin/printf
64 lockfileremove=/usr/bin/lockfile-remove
65 lockfilecreate=/usr/bin/lockfile-create
66 lockfiletouch=/usr/bin/lockfile-touch
67 
68 # Must have gettext first to display error messages
69 [ -x "$gettext" ] || { echo "Cannot execute $gettext"; exit 1 ; }
70 
71 for i in $awk $grep $cat $zcat $head $id $sort $rm $sed $cut $tail $ls $printf $lockfileremove $lockfilecreate $lockfiletouch
72 do
73  [ -x "$i" ] || { echo "$($gettext "Unable to execute") ${i}."; exit 1 ; }
74 done
75 
76 
77 #-------------------------
78 set_messages()
79 #-------------------------
80 {
81  # Language-dependent messages
82  # Uses gettext and mo files.
83  # Don't change these messages, change the .po file instead.
84  USAGE=$($gettext -e "Usage: top_mysql_users [ options ] number\n\ntop_mysql_users is a program that gives brief statistics\non mysql usage by parsing the mysql logs.\n\nOptions:\n -h, --help This help text.\n -v, --version Show version.\n -z, --use-gz-logs Parse gzipped and .1, ...n apache logs instead of just parsing the current log.\n -n, --number=NUMBER parse the NUMBER last lines of the current log.\n This option is not compatible with the --use-gz-logs option.\nSee the top_mysql_users(8) manual page for more information.")
85  NOT_FOUND_MSG=$($gettext "does not exist.")
86  NON_NUM_MSG=$($gettext "The \"number\" argument must be a number.")
87  NON_COMPATIBLE_MSG=$($gettext "The -n and -z options are not compatible.")
88  NON_NUM_MSG_FOR_N=$($gettext "The -n option requieres a number as argument.")
89  LOCKFILE_CREATION_FAILED=`$printf "$($gettext "%s is allready beeing executed.")" $PROG_NAME`
90  NON_ROOT_MSG=$($gettext "You have to be root (uid 0) to execute this program.")
91  HIT_RES_MSG=`$printf "$($gettext "Top %s mysql users, sorted by connexion number (using gzipped logs: %s):")" $NB_USERS $($gettext "$USE_GZ_LOGS")`
92  MISSING_CONF_FILE=`$printf "$($gettext "Can't find %s. Are you sure AlterncC is properly installed?")" $ALTERNC_CONF_FILE`
93  UNKNOWN_OPTION=$($gettext "Unknown %s option.")
94 }
95 
96 
97 #-------------------------
98 trap_EXIT()
99 #-------------------------
100 {
101  # Does some cleaning
102  $rm -f $RES_FILE
103  $lockfileremove $LOCK_FILE
104  exit
105 }
106 trap trap_EXIT INT KILL TERM QUIT ABRT STOP HUP
107 
108 
109 #-------------------------
110 # Main
111 #-------------------------
112 set_messages
113 # Must be root
114 [ "`$id -u`" != "0" ] && { echo $NON_ROOT_MSG ; exit 1 ; }
115 
116 # Parse args
117 IS_N_PARAM=false
118 USE_GZ_LOGS="$NO"
119 N_PARAM=""
120 COMMAND=$cat
121 for ARG in "$@" ; do
122  [ "$IS_N_PARAM" = "true" ] && { shift ; IS_N_PARAM=false ; continue ; }
123  [ "`$printf "$ARG\n" | $cut -c1`" != "-" ] && [ "$IS_N_PARAM" = "false" ] && break
124 
125  case $ARG in
126  -h | --help ) echo $PROG_NAME version $PROG_VERSION ; $printf "$USAGE\n" ; exit ;;
127  -v | --version ) echo $PROG_NAME version $PROG_VERSION ; exit ;;
128  -z | --use-gz-logs ) USE_GZ_LOGS="$YES" ;;
129  -n | --number=* )
130  if [ "$ARG" != "-n" ] ; then
131  N_PARAM=`echo $ARG | $cut -d"=" -f2`
132  else
133  N_PARAM=$2
134  IS_N_PARAM=true
135  fi
136  [ `echo "$N_PARAM" | $grep -c [^0-9]` != 0 ] && { echo "$NON_NUM_MSG_FOR_N" ; exit 1 ; }
137  COMMAND="$tail -n $N_PARAM"
138  ;;
139  *) $printf "${UNKNOWN_OPTION}\n" $ARG ; exit 1 ;;
140  esac
141  shift
142 done
143 
144 # -n and -z options are not compatible
145 [ "$USE_GZ_LOGS" = "$YES" ] && ! [ -z "$N_PARAM" ] && { echo $NON_COMPATIBLE_MSG ; exit 1 ; }
146 # Must have only 1 parameter
147 [ -z "$1" ] || [ "$#" -gt 1 ] && { $printf "$USAGE\n" ; exit 1 ; }
148 # Argument "number" must be numeric
149 [ `echo "$1" | $grep -c [^0-9]` != 0 ] && { echo "$NON_NUM_MSG" ; exit 1 ; } || NB_USERS=$1
150 # These dirs/files must exist
151 [ -d "$LOG_DIR" ] || { echo "$LOG_DIR $NOT_FOUND_MSG" ; exit 1 ; }
152 [ -d "$TMP_ROOT" ] || { echo "$TMP_ROOT $NOT_FOUND_MSG" ; exit 1 ; }
153 [ -f "$LOG_FILE" ] || { echo "$LOG_FILE $NOT_FOUND_MSG" ; exit 1 ; }
154 # Have to get AlternC conf file :
155 [ -f "$ALTERNC_CONF_FILE" ] || { echo $MISSING_CONF_FILE ; exit 1 ; } && . $ALTERNC_CONF_FILE
156 
157 # Prevents executing more than one shell at the same time
158 $lockfilecreate --retry 1 $LOCK_FILE
159 if [ $? != 0 ]
160 then
161  echo $LOCKFILE_CREATION_FAILED
162  exit 1
163 fi
164 $lockfiletouch $LOCK_FILE &
165 BADGER="$!"
166 
167 
168 # Does the stuff
169 set_messages
170 # Have to parse files one by one or else system wil go on knees
171 $COMMAND $LOG_FILE | $grep " Connect " | $awk -F "@" '{z=split($1, a, " ") ; account[a[z]]++} END {for (item in account) print item" "account[item]}' > $RES_FILE
172 for FILE in `$ls -1 $LOG_FILE.* | $grep -v "\.gz$"`; do
173  [ "$USE_GZ_LOGS" = "$YES" ] && [ -f $FILE ] && $cat $FILE | $grep " Connect " | $awk -F "@" '{z=split($1, a, " ") ; account[a[z]]++} END {for (item in account) print item" "account[item]}' >> $RES_FILE
174 done
175 if [ "$USE_GZ_LOGS" = "$YES" ]
176 then
177  for GZLOG in $LOG_FILE.*.gz
178  do
179  $zcat $GZLOG | $grep -e " Connect " | $awk -F "@" '{z=split($1, a, " ") ; account[a[z]]++} END {for (item in account) print item" "account[item]}' >> $RES_FILE
180  done
181 fi
182 
183 
184 # show results
185 echo $HIT_RES_MSG
186 $cat $RES_FILE | $awk '{account[$1]+=$2} END {for (item in account) print item" "account[item]}' | $awk {'printf ("%20.0f %s\n", $2, $1)'} | $sort -gr | $head -n$NB_USERS
187 
188 
189 # cleanly exit and remove temp files
190 kill "${BADGER}"
191 trap_EXIT
192 
193